[![](https://zenodo.org/badge/226863521.svg)](https://zenodo.org/doi/10.5281/zenodo.10084456)
![](https://img.shields.io/github/commit-activity/m/hedyorg/hedy)
![](https://img.shields.io/github/last-commit/hedyorg/hedy)
![](https://img.shields.io/github/stars/hedyorg/hedy)
![](https://img.shields.io/github/contributors/hedyorg/hedy)
![](https://img.shields.io/github/issues/hedyorg/hedy)

![](static/images/Hedy-logo-96x96-round.png)
<div id="top"></div>

# Hedy

Hedy is a gradual programming language aimed at teaching programming and teaching Python. It teaches using different levels. The first level just offers printing text and asking for input. This level is meant to introduce learners to the idea of a programming language, and the environment. From there, Hedy builds up to include more complex syntax and additional concepts.

[Bug Report](https://github.com/hedyorg/hedy/issues/new?assignees=&labels=&projects=&template=bug_report.md&title=%5BBUG%5D) · [Content Issue](https://github.com/hedyorg/hedy/issues/new?assignees=&labels=&projects=&template=content.md&title=%5BCONTENT%5D) · [Idea for the Hedy interface](https://github.com/hedyorg/hedy/issues/new?assignees=&labels=&projects=&template=idea-for-the-hedy-interface.md&title=%5BUI+idea%5D) · [Idea for the Hedy language](https://github.com/hedyorg/hedy/issues/new?assignees=&labels=&projects=&template=idea-for-the-hedy-language.md&title=%5BLANGUAGE+idea%5D)

# Preview

![](https://user-images.githubusercontent.com/1003685/230636245-668ef2a1-c38b-47cf-84e4-0896ee6a72e8.png)

The latest version of Hedy can be found at [hedy.org](https://hedy.org).

> You can also download Hedy and run it on your own machine. For more information, see [Offline Hedy](https://github.com/hedyorg/hedy/wiki/Offline-Hedy).

# Repo stats

![Repo Beats statistics](https://repobeats.axiom.co/api/embed/a3206e7c42293ee71446a7081b9c98636953501c.svg "Repobeats analytics image")

## What's next?

If you want to see what the core team will work on next, you can follow [our Project Board](https://github.com/orgs/hedyorg/projects/1/views/5), the [Discussions](https://github.com/hedyorg/hedy/discussions) or join our [Discord](https://discord.gg/8yY7dEme9r) channel.

## Živjo Hedy! Привет Hedy! !Hedy سلام

A simple way to help out Hedy is to [help us translate Hedy](https://github.com/hedyorg/hedy/wiki/Hedy-Translation-Tutorial) using Weblate! You do not need programming experience or knowledge to translate Hedy. Below the current status, help us complete a language, or add a new one.

[![](https://hosted.weblate.org/widgets/hedy/-/multi-auto.svg)](https://hosted.weblate.org/engage/hedy/)

## I found a bug!

Oh no! Here is how you can let us know:

* If it is a small fix and clearly wrong (such as a crash or a wrong error message) please [make an issue](https://github.com/hedyorg/hedy/issues/new/choose). 

* If it is more of an idea, please reach out to us on [Discord](https://discord.gg/8yY7dEme9r).

Please note that we are a friendly and welcoming open source project. If you submit an issue, refrain from saying things are "bad", or "wrong" or "broken". Assume that code that is there was made by people that do their best! Neutrally phrased messages are nicer for everyone. For example use "did not do what I expected", "appears not to work" or "could be improved". For full community guidelines, please read the [Hedy Wiki](https://github.com/hedyorg/hedy/wiki)
Also feel free to join our [Discord](https://discord.gg/8yY7dEme9r) server to discuss ideas, and get in touch with us our show of your Hedy related creations.

## I want to contribute 

Great, thanks!! 

Before you start, please consult the ["before your first contribution"](https://github.com/hedyorg/hedy/wiki#getting-started-on-your-first-contribution) section of our Wiki. First contributions that are not linked to issues either labeled "good first issue" or "approved", or that do not link to any issues will be closed. We don't have the bandwidth to inspect pull requests that are not aligned with our goals. If you need any help getting started, the Wiki is the best place to start, and you can also always drop into the Discord! (in #programmers-general).

## Thanks to all Contributors

Thank you very much for taking your time to help Hedy.

[![Contributors](https://contrib.rocks/image?repo=hedyorg/hedy)]([https://github.com/codemaniac-sahil/news-webapp-api](https://github.com/hedyorg/hedy)https://github.com/hedyorg/hedy/graphs/contributors)
<p align="right">(<a href="#top">🔼 Back to top</a>)</p>
